 #include <QTRSensors.h>
#include <DRV8835MotorShield.h>
#define KP 0.090  // kp = 0.30  0.15  2.35   5.35       2
#define KD 2 //kd .6        2.2    9.50    18         35
#define M1_MAX_SPEED 550
#define M2_MAX_SPEED 550
#define M1_DEFAULT_SPEED 450
#define M2_DEFAULT_SPEED 450
//#define MIDDLE_SENSOR 3, 4 
#define NUM_SENSORS  6     //количество используемых датчиков
#define TIMEOUT 2500
#define EMITTER_PIN 2      //пин для управления датчиками 
#define DEBUG 1 //выводит в монитор порта показания с датчиков
DRV8835MotorShield motors;
QTRSensorsRC qtrrc((unsigned char[]) {20, 19, 18, 17, 16, 15} ,NUM_SENSORS, TIMEOUT, EMITTER_PIN); // Обозначаем датчики по порядку
unsigned int sensorValues[NUM_SENSORS];

//motors.flipM1(true);
//motors.flipM2(true) поменять стороны моторов
void setup()
{
  
  manual_calibration(); 
}
int lastError = 0;
int  last_proportional = 0;
int integral = 0;
void loop()
{
  unsigned int sensors[6];
  int position = qtrrc.readLine(sensors);
  int error = position - 2500;
  int motorSpeed = KP * error + KD * (error - lastError);// Формула пропорционального регулятора
  lastError = error;
  int rightMotorSpeed = M2_DEFAULT_SPEED + motorSpeed; //Меняет скорость моторов по принципу пропорционального регулятора  
  int leftMotorSpeed = M1_DEFAULT_SPEED - motorSpeed;
    if (rightMotorSpeed > M1_MAX_SPEED ) rightMotorSpeed = M1_MAX_SPEED; //сохраняет максимальную скорость
  if (leftMotorSpeed > M2_MAX_SPEED ) leftMotorSpeed = M2_MAX_SPEED; //сохраняет максимальную скорость
  if (rightMotorSpeed < 0) rightMotorSpeed = 0; //не дает моторам поехать в другую сторону
  if (leftMotorSpeed < 0) leftMotorSpeed = 0; //не дает моторам поехать в другую сторону
   {
motors.setM1Speed(rightMotorSpeed); //Работает только в том случае, если присутствует строчка обозначения моторов "DRV8835MotorShield motors;"
motors.setM2Speed(leftMotorSpeed);

}
}
void manual_calibration() {
  int i;
  for (i = 0; i < 250; i++)  // каллибрация
  {
    qtrrc.calibrate(QTR_EMITTERS_ON);
    delay(20);
  }
  if (DEBUG) { // Выводит в монитор порта показания с каллибрации
    Serial.begin(9600);
    for (int i = 0; i < NUM_SENSORS; i++)
    {
      Serial.print(qtrrc.calibratedMinimumOn[i]);
      Serial.print(' ');
    }
    Serial.println();
    for (int i = 0; i < NUM_SENSORS; i++)
{
  Serial.print(qtrrc.calibratedMaximumOn[i]);
  Serial.print(' ');
}

  }
}
